unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    procedure ThreadsDone(Sender: TObject);
  public
    { Public declarations }
  end;

  TCriticalSectionThread = class(TThread)
  protected
    procedure Execute; override;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  MaxSize = 128;
var
  NextNumber: Integer = 0;
  DoneFlags: Integer = 0;
  GlobalArray: array[1..MaxSize] of Integer;
  CS: TRTLCriticalSection;

function GetNextNumber: Integer;
begin
  Result := NextNumber; // return global var
  Inc(NextNumber); // inc global var
end;

{ TRaceThread }

procedure TCriticalSectionThread.Execute;
var
  i: Integer;
begin
  inherited;

  OnTerminate := Form1.ThreadsDone;

  EnterCriticalSection(CS); // CS begins here

  for i := 1 to MaxSize do
  begin
    GlobalArray[i] := GetNextNumber; // set array element
    Sleep(5); // let thread intertwine
  end;

  LeaveCriticalSection(CS); // CS ends here

end;

{ TForm1 }

procedure TForm1.ThreadsDone(Sender: TObject);
var
  i: Integer;
begin
  inc(DoneFlags);
  if DoneFlags = 2 then
  begin // make sure both threads finished
    for i := 1 to MaxSize do
       { fill listbox with array contents }
      Listbox1.Items.Add(IntToStr(GlobalArray[i]));
    DeleteCriticalSection(CS);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  InitializeCriticalSection(CS);
  TCriticalSectionThread.Create(False); // create threads
  TCriticalSectionThread.Create(False);
end;

end.

