unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Button1: TButton;
    ListBox2: TListBox;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    procedure ThreadsDone(Sender: TObject);
  public
    { Public declarations }
  end;

  TDeadLockThread = class(TThread)
  private
    procedure dothread;
  protected
    procedure Execute; override;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  MaxSize = 128;


{ TRaceThread }

procedure TDeadLockThread.dothread;
var
  i: Integer;
begin
  Form1.ListBox2.Items.Add('TDeadLockThread Start');
  for i := 1 to MaxSize do
  begin
    Form1.ListBox2.Items.Add('TDeadLockThread Count = ' + IntToStr(i));
    Sleep(5); // let thread intertwine
  end;
  Form1.ListBox2.Items.Add('TDeadLockThread Stop');
end;

procedure TDeadLockThread.Execute;
begin
  inherited;

  OnTerminate := Form1.ThreadsDone;
  Synchronize(dothread);
end;

{ TForm1 }

procedure TForm1.ThreadsDone(Sender: TObject);
var
  i: integer;
begin
  ListBox2.Items.Add('TDeadLockThread Done!');
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i: integer;
  thread: TDeadLockThread;
begin
  ListBox1.Items.Add('Main Thread Start');

  thread := TDeadLockThread.Create(False); // create threads

  Application.ProcessMessages;


  if WaitForSingleObject(thread.Handle, 1000 * 5) = WAIT_TIMEOUT then
  begin
    ListBox1.Items.Add('WaitForSingleObject TimeOut');
  end;


  ListBox1.Items.Add('Main Thread Stop');
end;

end.

